#!/bin/bash
#
# Author: SAKIMA Kimihisa
# Contact: sakima@hooktail.org
# Date: $Date: 2005-07-24 11:34:52 $
#
#
# ̾
#   kagipdf.sh - kagipdfġΥեȥ
#
# 
#   kagipdf.sh [OPTION] [FILE]
#
# ץ
#   -k e : LaTeXեʸɤ euc-jp ˥åȡʥǥեȡ
#   -k s : LaTeXեʸɤ Shift-JIS ˥å
#   -k u : LaTeXեʸɤ UTF-8 ˥å
#   -n   : LaTeXѥ¹Ԥʤ
#   -o   : ȥץåȥե̾
#
# 
#   ʪΤץȡhttp://hooktail.org/wiki/ˤѤ
#   Ƥ񼰡reStructuredText١ˤ顤pdfե
#   롥
#
# ¸
#   * ruby
#   * Docutils
#   * lv
#   * pLaTeX
#   * jsarticleܸLaTeXɥȥ饹
#   * dvipdfmx
#   * ImageMagick
#
# ToDo
#   * platexѥ˼ԤȤνä
#   * @@reference: @@ ̿б
#   * ¹ԻˡΥץդ褦ˤ
#
############################################################
CMDNAME=`basename $0`
usage ()
{
  echo "Usage: $CMDNAME [OPTION] [FILE]"
  echo ""
  echo "OPTION"
  echo "-k e : Set the output charset for EUC-JP."
  echo "-k s : Set the output charset for Jhift JIS."
  echo "-k u : Set the output charset for UTF-8"
  echo "-n   : LaTeX conpiling chansel."
  echo "-o   : Set output file name."
}


###
### USER SETTINGS
###

# rst2latex.py դ륪ץ
DOCUTILS_OPT="--use-latex-docinfo --use-latex-footnotes"
STYLE="--stylesheet=hooktail.sty"

# dvipdfmx դ륪ץ
DVIPDFMX_OPT="-O -E 2"



###
### ץ
###

CHAR=e
NOCONPILE=FALSE
OUTFILE=
OPT=
while getopts n:k:o: OPT
do
  case $OPT in
    k)  CHAR=$OPTARG
        ;;
    n)  NOCONPILE=$OPTARG
        ;;
    o)  OUTFILE=$OPTARG
        ;;
    /?) usage 1>&2
        exit 1
        ;;
  esac
done
shift `expr $OPTIND - 1`



###
### ϥ󥳡 (ǥեȤ euc-jp)
###

if [ "$CHAR" = "e" ]; then
  NKFOPT="-Lu -e"
  KAGITEXOPT="-e"
elif [ "$CHAR" = "s" ]; then
  NKFOPT="-Lw -s"
  KAGITEXOPT="-s"
elif [ "$CHAR" = "u" ]; then
  NKFOPT="-w"
  KAGITEXOPT="-u"
else
  usage 1>&2
  exit 1
fi



###
### ν
###

# ο
if [ $# -lt 0 -o $# -gt 2 ]; then
  echo "$USAGE" 1>&2
  exit 1
fi

# ǥ쥯ȥλ
if [ $# -eq 2 ]; then
  DIR="$2"
  #ꤵ줿ǥ쥯ȥ꤬¸ߤ뤫
  if [ ! -d "$2" ]; then
    echo "$2 is not a directory." 1>&2
    exit 1
  fi
else
  DIR="."
fi



###
### NAME SETTINGS
###

if [ "$OUTFILE" = "" ]; then
  FILEBODY="$DIR/${1%.*}"  # ϥե̾ĥҤ
else
  FILEBODY="$DIR/${OUTFILE%.*}"  # ϥե̾ĥҤ
fi

STRICTFILE="$DIR/$FILEBODY.reST"
TMPFILE="$DIR/tmp$$"
  



###
### ִ
###

lv -Ou8 $1 | kagipdfDispMath.rb | kagipdfInMath.rb > $TMPFILE



###
###  eps ˤ@@̿
###

kagipdfEps.rb < $TMPFILE 2> /dev/null | kagipdfAtAt.rb  > $STRICTFILE



###
### rst2latex ¹
###

rst2latex.py -o utf-8 $DOCUTILS_OPT $STRICTFILE $TMPFILE



###
### 줿 LaTeX եԽ
###

lv -Ou8 $TMPFILE | kagipdfTex.sh $KAGITEXOPT | nkf $NKFOPT > $FILEBODY.tex
rm $TMPFILE



###
### LaTeX ѥ롤pdf Ѵ
###

if [ "$NOCONPILE" = "FALSE" -o "$NOCONPILE" = "pdf" ]; then
  # platex 2Ϣ³ѥ (ܼꡤ߻ȤΤ)
  if platex $FILEBODY.tex | grep -q "^Output written on"; then # 1ܤ
    # ä platex
    platex $FILEBODY.tex >/dev/null
    # dvipdfmx ¹
    if [ ! "$NOCONPILE" = "pdf" ]; then
      dvipdfmx $FILEBODY >/dev/null 2>&1
    fi
    # ʤե
    rm $FILEBODY.aux $FILEBODY.log $FILEBODY.out
    #rm $FILEBODY.dvi $FILEBODY.reST
  fi
fi

# ѥ뼺
# Υץ鵯ư줿 platex ץʤ (̤)
#PID=`ps auxw | sed '1d' | grep "platex" | grep -v grep | grep " S " | awk '{print $2}'`
#if [ "$PID" != "" ]; then
#  kill -9 $PID
#fi
